unit Hood1;
interface
uses Classes;

 procedure ListComponentProperties(Component: TComponent; var Strings: TStringList);

implementation
uses TypInfo, SysUtils;

procedure ListComponentProperties(Component: TComponent; var Strings: TStringList);
var
 Count, Size, I: Integer;
 List: PPropList;
 PropInfo: PPropInfo;
 PropOrEvent, PropValue: string;
begin
 Count := GetPropList(Component.ClassInfo, tkAny, nil);
 Size  := Count * SizeOf(Pointer);
 GetMem(List, Size);
 try
   Count := GetPropList(Component.ClassInfo, tkAny, List);
   for I := 0 to Count - 1 do begin
     PropInfo := List^[I];
     if PropInfo^.PropType^.Kind in tkMethods then
       PropOrEvent := 'Event'
     else
       PropOrEvent := 'Property';
     PropValue := GetPropValue(Component, PropInfo^.Name);
     Strings.Add(Format('[%s] %s: %s = %s', [PropOrEvent, PropInfo^.Name,
                                             PropInfo^.PropType^.Name, PropValue]));
   end;
 finally
   FreeMem(List);
 end;
end;

end.


